## pxp 1.1.4

=== Makefile ===
# make all: compiles the configured packages with ocamlc
# make opt: compiles the configured packages with ocamlopt
# make install: installs the configured packages
# make clean: cleans everything up

# Inclusion of Makefile.conf may fail when cleaning up:
-include Makefile.conf

NAME=pxp
TOP_DIR=.

.PHONY: all
all:
	$(MAKE) -C tools all
	for pkg in $(PKGLIST); do $(MAKE) -C src/$$pkg all || exit; done

.PHONY: opt
opt:
	for pkg in $(PKGLIST); do $(MAKE) -C src/$$pkg opt || exit; done

# The following PHONY rule is important for Cygwin:
.PHONY: install
install:
	for pkg in $(PKGLIST); do $(MAKE) -C src/$$pkg install || exit; done

.PHONY: uninstall
uninstall:
	$(MAKE) -C src uninstall	

.PHONY: clean
clean:
	rm -f Makefile.conf
	$(MAKE) -C tools CLEAN
	$(MAKE) -C src CLEAN
	$(MAKE) -C examples CLEAN
	$(MAKE) -C rtests CLEAN

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean:
	rm -f Makefile.conf
	$(MAKE) -C tools distclean
	$(MAKE) -C src distclean
	$(MAKE) -C examples distclean
	$(MAKE) -C rtests distclean
	$(MAKE) -C doc distclean

.PHONY: RELEASE
RELEASE:
	./configure -version >RELEASE

.PHONY: dist
dist: RELEASE
	./release

.PHONY: tag-release
tag-release: RELEASE
	@echo Checking whether everything is checked in...
	! cvs -n update 2>&1 | grep '^[MACPU] '
	r=`head -1 RELEASE | sed -e s/\\\./-/g`; cd ..; cvs tag -F $(NAME)-$$r pxp

.PHONY: release
release: 
	$(MAKE) tag-release
	$(MAKE) dist

=== examples/Makefile ===
.PHONY: all
all:

.PHONY: clean
clean:

.PHONY: CLEAN
CLEAN: clean
	$(MAKE) -C xmlforms CLEAN
	$(MAKE) -C validate CLEAN
	$(MAKE) -C readme CLEAN
	$(MAKE) -C simple_transformation CLEAN
	$(MAKE) -C namespaces CLEAN

.PHONY: distclean
distclean: clean
	rm -f *~
	$(MAKE) -C xmlforms distclean
	$(MAKE) -C validate distclean
	$(MAKE) -C readme distclean
	$(MAKE) -C simple_transformation distclean
	$(MAKE) -C namespaces distclean

=== rtests/Makefile ===
.PHONY: all
all:
	$(MAKE) -C reader
	$(MAKE) -C write
	$(MAKE) -C codewriter
	$(MAKE) -C canonxml
	$(MAKE) -C negative
	$(MAKE) -C dynamic

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.cmxa

.PHONY: CLEAN
CLEAN: clean
	$(MAKE) -C reader clean
	$(MAKE) -C write clean
	$(MAKE) -C codewriter clean
	$(MAKE) -C canonxml clean
	$(MAKE) -C negative clean
	$(MAKE) -C dynamic clean

.PHONY: distclean
distclean: clean
	rm -f *~
	rm -f dumpfiles
	$(MAKE) -C reader distclean
	$(MAKE) -C write distclean
	$(MAKE) -C codewriter distclean
	$(MAKE) -C canonxml distclean
	$(MAKE) -C negative distclean
	$(MAKE) -C dynamic distclean

dumpfiles: dumpfiles.ml
	ocamlc -o dumpfiles dumpfiles.ml

=== src/Makefile ===
all:
	false

clean:

distclean:
	$(MAKE) -C pxp distclean
	$(MAKE) -C pxp-engine distclean
	$(MAKE) -C pxp-lex-iso88591 distclean
	$(MAKE) -C pxp-lex-utf8 distclean
	$(MAKE) -C pxp-wlex distclean

CLEAN:
	$(MAKE) -C pxp CLEAN
	$(MAKE) -C pxp-engine CLEAN
	$(MAKE) -C pxp-lex-iso88591 CLEAN
	$(MAKE) -C pxp-lex-utf8 CLEAN
	$(MAKE) -C pxp-wlex CLEAN

uninstall:
	$(MAKE) -C pxp uninstall
	$(MAKE) -C pxp-engine uninstall
	$(MAKE) -C pxp-lex-iso88591 uninstall
	$(MAKE) -C pxp-lex-utf8 uninstall
	$(MAKE) -C pxp-wlex uninstall

=== tools/Makefile ===
TOP_DIR = ..
include $(TOP_DIR)/Makefile.rules

all:
	$(MAKE) -C src
	test -f m2parsergen$(EXEC_SUFFIX) || ln -s src/m2parsergen/m2parsergen$(EXEC_SUFFIX) .
	test -f ucs2_to_utf8$(EXEC_SUFFIX) || ln -s src/ucs2_to_utf8/ucs2_to_utf8$(EXEC_SUFFIX) .

clean:
	rm -f m2parsergen$(EXEC_SUFFIX) ucs2_to_utf8$(EXEC_SUFFIX)

CLEAN: clean
	$(MAKE) -C src CLEAN

distclean: clean
	$(MAKE) -C src distclean

=== doc/manual/Makefile ===
# Note: The following Makefile works for _me_. The stable releases of
# PXP contain an already built manual, so you do not need this Makefile.

# The following software is required:
# - jade/sp
# - docbook 3.x (Davenport Group)
# - docbook stylesheets by Normal Walsh
#
# Furthermore, you need an ocaml toploop "ocamlfattop" that can be
# built by:
# ocamlfind ocamlmktop -o ocamlfattop -package str,unix,findlib -linkpkg

DOCBOOK_HTML = /usr/share/sgml/docbkdsl/html
DOCBOOK_PRINT = /usr/share/sgml/docbkdsl/print
SRC = $(PWD)/src

SOURCE = ../../src/pxp-engine/pxp_document.mli \
         ../../src/pxp-engine/pxp_types.mli
UPSOURCE = $(shell for x in $(SOURCE); do echo "../$$x"; done)

.PHONY: html ps

default: html ps

html: html/book1.htm html/pic/done

ps: ps/pxp.ps ps/pic/done


src/readme.ent: ../../examples/readme/to_html.ml
	src/getcode.ml <../../examples/readme/to_html.ml >src/readme.ent

src/yacc.mli.ent: ../../src/pxp-engine/pxp_yacc.mli
	src/getcode.ml <../../src/pxp-engine/pxp_yacc.mli >src/yacc.mli.ent

src/dtd.mli.ent: ../../src/pxp-engine/pxp_dtd.mli
	src/getcode.ml <../../src/pxp-engine/pxp_dtd.mli >src/dtd.mli.ent

src/extracted.ent: $(SOURCE)
	mkdir -p src/extracted
	rm -f src/extracted/*
	(cd src; ./extract.ml $(UPSOURCE))

html/book1.htm: src/*.sgml src/readme.ent src/yacc.mli.ent src/dtd.mli.ent src/extracted.ent
	mkdir -p html
	cp src/markup.css html; \
	cd html; \
	rm -f *.htm*; \
	jade -t sgml -D$(DOCBOOK_HTML) -D$(SRC) -ihtml markup.sgml; \
	true
	touch html/TIMESTAMP

html/pic/done: src/pic/*.fig
	mkdir -p html/pic
	l=`cd src/pic; echo *.fig`; \
	for x in $$l; do fig2dev -L gif src/pic/$$x html/pic/`basename $$x .fig`.gif; done
	touch html/pic/done

#man: src/findlib_reference.xml
#	mkdir -p man
#	cd man; \
#	rm -f *.[0-9]; \
#	db2man <../src/findlib_reference.xml

ps/markup.tex: src/*.sgml src/readme.ent src/yacc.mli.ent src/dtd.mli.ent
	mkdir -p ps
	cd ps; \
	jade -t tex -D$(DOCBOOK_PRINT) -D$(SRC) markup.sgml; \
	true

ps/markup.dvi: ps/markup.tex ps/pic/done
	cd ps; \
	jadetex markup.tex; \
	jadetex markup.tex; \
	jadetex markup.tex

ps/pxp.ps: ps/markup.dvi
	cd ps; \
	dvips -f <markup.dvi >pxp.ps

ps/pic/done: src/pic/*.fig
	mkdir -p ps/pic
	l=`cd src/pic; echo *.fig`; \
	for x in $$l; do fig2dev -L ps -m 0.8 src/pic/$$x ps/pic/`basename $$x .fig`.ps; done
	touch ps/pic/done

.SUFFIXES: .xml .sgml

.sgml.xml: 
	sx -xndata $< >$@; true



clean:
	rm -rf html man ps
	rm -f src/readme.ent

CLEAN: clean

distclean:
	rm -f src/*~
	rm -f *~
	rm -f ps/*.aux ps/*.dvi ps/*.log ps/*.tex

=== examples/validate/Makefile ===
# make validate:        make bytecode executable
# make validate.opt:    make native executable
# make clean: 		remove intermediate files (in this directory)
# make CLEAN:           remove intermediate files (recursively)
# make distclean: 	remove any superflous files (recursively)
#----------------------------------------------------------------------

pxpvalidate: validate.ml
	ocamlfind ocamlc -g -o pxpvalidate -package "pxp,unix,str" -linkpkg validate.ml

pxpvalidate.opt: validate.ml
	ocamlfind ocamlopt -o pxpvalidate.opt -package "pxp,unix,str" -linkpkg validate.ml

BYTEPKG = pxp-engine pxp-lex-iso88591 pxp-lex-utf8

# The following rules to create the bytecode executable assume O'Caml 3.03:

pxpvalidate.byte: validate.ml
	ocamlfind ocamlc -o pxpvalidate.byte -package "pxp,unix,str" -linkpkg validate.ml

pxpvalidate.1: pxpvalidate.pod
	pod2man --section=1 --center "www.ocaml-programming.de" --release 'PXP 1.1 tools' --lax pxpvalidate.pod >pxpvalidate.1

releasebyte:
	(cd ..; tar czf pxpvalidate-1.1.1.tar.gz pxpvalidate/{INSTALL,LICENSE,Makefile,pxpvalidate.1,pxpvalidate.byte,setup.sh,validate.ml})

#----------------------------------------------------------------------
.PHONY: all
all:

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa 

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~
	rm -f pxpvalidate pxpvalidate.opt pxpvalidate.byte interpreter

=== rtests/canonxml/Makefile ===
# make validate:        make bytecode executable
# make validate.opt:    make native executable
# make clean: 		remove intermediate files (in this directory)
# make CLEAN:           remove intermediate files (recursively)
# make distclean: 	remove any superflous files (recursively)
#----------------------------------------------------------------------

OCAMLPATH=../../src

test_canonxml: test_canonxml.ml
	ocamlfind ocamlc -g -custom -o test_canonxml -package pxp,str -linkpkg test_canonxml.ml

#----------------------------------------------------------------------
.PHONY: all
all:

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa out.xml

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~
	rm -f test_canonxml

=== rtests/codewriter/Makefile ===
# make validate:        make bytecode executable
# make validate.opt:    make native executable
# make clean: 		remove intermediate files (in this directory)
# make CLEAN:           remove intermediate files (recursively)
# make distclean: 	remove any superflous files (recursively)
#----------------------------------------------------------------------

OCAMLPATH=../../src

all: compile marshal_simple marshal_namespace marshal_recode

compile: compile.ml
	ocamlfind ocamlc -g -custom -o compile -package pxp,str -linkpkg compile.ml

marshal_simple: marshal_simple.ml
	ocamlfind ocamlc -g -custom -o marshal_simple -package pxp,str -linkpkg marshal_simple.ml

marshal_namespace: marshal_namespace.ml
	ocamlfind ocamlc -g -custom -o marshal_namespace -package pxp,str -linkpkg marshal_namespace.ml

marshal_recode: marshal_recode.ml
	ocamlfind ocamlc -g -custom -o marshal_recode -package pxp -linkpkg marshal_recode.ml


#----------------------------------------------------------------------
.PHONY: all
all:

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa sample sample.ml out1 out2
	rm -f *.d1 *.d2 *.d3 *.out *.out1 *.out2

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~
	rm -f compile marshal_simple marshal_namespace marshal_recode

=== rtests/dynamic/Makefile ===
# make validate:        make bytecode executable
# make validate.opt:    make native executable
# make clean: 		remove intermediate files (in this directory)
# make CLEAN:           remove intermediate files (recursively)
# make distclean: 	remove any superflous files (recursively)
#----------------------------------------------------------------------

OCAMLPATH=../../src

all: create_element modify strip

create_element: create_element.ml
	ocamlfind ocamlc -labels -g -custom -o create_element -package pxp -linkpkg create_element.ml

modify: modify.ml
	ocamlfind ocamlc -g -custom -o modify -package pxp -linkpkg modify.ml

strip: strip.ml
	ocamlfind ocamlc -g -custom -o strip -package pxp -linkpkg strip.ml

#----------------------------------------------------------------------
.PHONY: all
all:

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa out.xml

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~
	rm -f create_element modify strip

=== rtests/negative/Makefile ===
# make test_negative:   make bytecode executable
# make clean: 		remove intermediate files (in this directory)
# make CLEAN:           remove intermediate files (recursively)
# make distclean: 	remove any superflous files (recursively)
#----------------------------------------------------------------------

OCAMLPATH=../../src

test_negative: test_negative.ml
	ocamlfind ocamlc -g -custom -o test_negative -package pxp,str -linkpkg test_negative.ml

#----------------------------------------------------------------------
.PHONY: all
all:

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa current.out

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~
	rm -f test_negative

=== rtests/reader/Makefile ===
# make validate:        make bytecode executable
# make validate.opt:    make native executable
# make clean: 		remove intermediate files (in this directory)
# make CLEAN:           remove intermediate files (recursively)
# make distclean: 	remove any superflous files (recursively)
#----------------------------------------------------------------------

OCAMLPATH=../../src

test_reader: test_reader.ml
	ocamllex minilex.mll
	ocamlfind ocamlc -custom -o test_reader -package pxp,unix,threads \
		-linkpkg -thread \
		-g minilex.ml test_reader.ml

#----------------------------------------------------------------------
.PHONY: all
all:

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa minilex.ml

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~
	rm -f test_reader

## pxp 1.1.94.2

=== Makefile ===
--- 
+++ 
@@ -3,49 +3,57 @@
 # make install: installs the configured packages
 # make clean: cleans everything up
 
-# Inclusion of Makefile.conf may fail when cleaning up:
--include Makefile.conf
-
 NAME=pxp
 TOP_DIR=.
+
+include Makefile.rules
 
 .PHONY: all
 all:
 	$(MAKE) -C tools all
 	for pkg in $(PKGLIST); do $(MAKE) -C src/$$pkg all || exit; done
+	for pkg in $(GENPKGLIST); do $(MAKE) -C gensrc/$$pkg generate || exit; done
+	for pkg in $(GENPKGLIST); do $(MAKE) -C gensrc/$$pkg all || exit; done
 
 .PHONY: opt
 opt:
 	for pkg in $(PKGLIST); do $(MAKE) -C src/$$pkg opt || exit; done
+	for pkg in $(GENPKGLIST); do $(MAKE) -C gensrc/$$pkg opt || exit; done
 
 # The following PHONY rule is important for Cygwin:
 .PHONY: install
 install:
 	for pkg in $(PKGLIST); do $(MAKE) -C src/$$pkg install || exit; done
+	for pkg in $(GENPKGLIST); do $(MAKE) -C gensrc/$$pkg install || exit; done
 
 .PHONY: uninstall
 uninstall:
 	$(MAKE) -C src uninstall	
+	for pkg in $(ALLGENPKGLIST); do $(OCAMLFIND) remove $$pkg; done
+
+# On the toplevel, clean is CLEAN:
 
 .PHONY: clean
 clean:
-	rm -f Makefile.conf
 	$(MAKE) -C tools CLEAN
 	$(MAKE) -C src CLEAN
+	for dir in gensrc/pxp-*; do $(MAKE) -C $$dir CLEAN || true; done
 	$(MAKE) -C examples CLEAN
 	$(MAKE) -C rtests CLEAN
+	rm -f .testscript .testout
 
 .PHONY: CLEAN
 CLEAN: clean
 
 .PHONY: distclean
 distclean:
-	rm -f Makefile.conf
+	rm -f *~ Makefile.conf
 	$(MAKE) -C tools distclean
 	$(MAKE) -C src distclean
 	$(MAKE) -C examples distclean
 	$(MAKE) -C rtests distclean
-	$(MAKE) -C doc distclean
+	test ! -f doc/Makefile || $(MAKE) -C doc distclean
+	for dir in gensrc/pxp-*; do if [ -f $$dir/gen_dir ]; then rm -rf $$dir; else $(MAKE) -C $$dir distclean; fi; done
 
 .PHONY: RELEASE
 RELEASE:

=== rtests/Makefile ===
--- 
+++ 
@@ -1,11 +1,15 @@
 .PHONY: all
 all:
-	$(MAKE) -C reader
-	$(MAKE) -C write
-	$(MAKE) -C codewriter
-	$(MAKE) -C canonxml
-	$(MAKE) -C negative
-	$(MAKE) -C dynamic
+	top=`dirname $$PWD` &&                     \
+	OCAMLPATH="$$top/gensrc:$$top/src" &&      \
+	export OCAMLPATH &&                        \
+	$(MAKE) -C reader &&                       \
+	$(MAKE) -C write &&                        \
+	$(MAKE) -C codewriter &&                   \
+	$(MAKE) -C canonxml &&                     \
+	$(MAKE) -C negative &&                     \
+	$(MAKE) -C dynamic &&                      \
+	$(MAKE) -C lex
 
 .PHONY: clean
 clean:
@@ -19,6 +23,7 @@
 	$(MAKE) -C canonxml clean
 	$(MAKE) -C negative clean
 	$(MAKE) -C dynamic clean
+	$(MAKE) -C lex clean
 
 .PHONY: distclean
 distclean: clean
@@ -30,6 +35,7 @@
 	$(MAKE) -C canonxml distclean
 	$(MAKE) -C negative distclean
 	$(MAKE) -C dynamic distclean
+	$(MAKE) -C lex distclean
 
 dumpfiles: dumpfiles.ml
 	ocamlc -o dumpfiles dumpfiles.ml

=== src/Makefile ===
all:
	false

clean:

distclean:
	$(MAKE) -C pxp distclean
	$(MAKE) -C pxp-engine distclean

CLEAN:
	$(MAKE) -C pxp CLEAN
	$(MAKE) -C pxp-engine CLEAN

uninstall:
	$(MAKE) -C pxp uninstall
	$(MAKE) -C pxp-engine uninstall

=== gensrc/pxp-wlex-utf8/Makefile ===
TOP_DIR = ../..
ENC = utf8
INPUT = $(TOP_DIR)/src/pxp-lex
MLL = $(shell echo pxp_wlex_$(ENC)_*.mll)
CMO = $(MLL:.mll=.cmo)
CMX = $(MLL:.mll=.cmx)
OCAMLC_OPTIONS = -I $(TOP_DIR)/src/pxp-engine
OCAMLOPT_OPTIONS = $(OCAMLC_OPTIONS)
PACKAGES = netstring,wlexing

include $(TOP_DIR)/Makefile.rules

.PHONY: all opt generate clean CLEAN distclean install uninstall

all: pxp_wlex_$(ENC).cma pxp_wlex_link_$(ENC).cmo

opt: pxp_wlex_$(ENC).cmxa pxp_wlex_link_$(ENC).cmx

pxp_wlex_$(ENC).cma: $(CMO)
	$(OCAMLC) -o pxp_wlex_$(ENC).cma -a $(CMO)

pxp_wlex_$(ENC).cmxa: $(CMX)
	$(OCAMLOPT) -o pxp_wlex_$(ENC).cmxa -a $(CMX)

generate: gen_done

gen_done: $(INPUT)/*.def $(INPUT)/*.src
	$(LEXPP) -charclasses "$(INPUT)/char_classes_wlex.def" \
		-lexsrc "$(INPUT)/lex.src" \
		-linksrc "$(INPUT)/link_wlex.src" \
		-encoding "$(ENC)" \
		-outlexprefix "pxp_wlex_$(ENC)" \
		-outlinkprefix "pxp_wlex_link_$(ENC)"
	for mll in *.mll; do echo "Doing $$mll:"; $(WLEX) $$mll; done
	touch gen_done

clean:
	rm -f $(CLEAN_LIST) *.ml *.mll gen_done

CLEAN: clean

# distclean is not clean, because the distribution contains the .ml files
# and gen_done
distclean: 
	rm -f $(CLEAN_LIST) META

install:
	files=`$(COLLECT_FILES) *.mli *.cmi *.cma *.cmxa *.a pxp_wlex_link_*.cmo pxp_wlex_link_*.cmx pxp_wlex_link_*.o META` && \
        $(OCAMLFIND) install pxp-wlex-$(ENC) $$files

uninstall:
	$(OCAMLFIND) remove pxp-wlex-$(ENC)

=== rtests/canonxml/Makefile ===
--- 
+++ 
@@ -4,8 +4,6 @@
 # make CLEAN:           remove intermediate files (recursively)
 # make distclean: 	remove any superflous files (recursively)
 #----------------------------------------------------------------------
-
-OCAMLPATH=../../src
 
 test_canonxml: test_canonxml.ml
 	ocamlfind ocamlc -g -custom -o test_canonxml -package pxp,str -linkpkg test_canonxml.ml

=== rtests/codewriter/Makefile ===
--- 
+++ 
@@ -4,8 +4,6 @@
 # make CLEAN:           remove intermediate files (recursively)
 # make distclean: 	remove any superflous files (recursively)
 #----------------------------------------------------------------------
-
-OCAMLPATH=../../src
 
 all: compile marshal_simple marshal_namespace marshal_recode

=== rtests/dynamic/Makefile ===
--- 
+++ 
@@ -4,8 +4,6 @@
 # make CLEAN:           remove intermediate files (recursively)
 # make distclean: 	remove any superflous files (recursively)
 #----------------------------------------------------------------------
-
-OCAMLPATH=../../src
 
 all: create_element modify strip

=== rtests/lex/Makefile ===
all: test_lex_utf8

# OCAMLPATH=../../gensrc:../../src


test_lex_utf8: test_lex_utf8.ml
	ocamlfind ocamlc -o test_lex_utf8 -package pxp-lex-utf8 -linkpkg \
		test_lex_utf8.ml

clean:
	rm -rf test_lex_utf8 *.cmo *.cmi

CLEAN: clean

distclean: clean

=== rtests/negative/Makefile ===
--- 
+++ 
@@ -3,8 +3,6 @@
 # make CLEAN:           remove intermediate files (recursively)
 # make distclean: 	remove any superflous files (recursively)
 #----------------------------------------------------------------------
-
-OCAMLPATH=../../src
 
 test_negative: test_negative.ml
 	ocamlfind ocamlc -g -custom -o test_negative -package pxp,str -linkpkg test_negative.ml

=== rtests/reader/Makefile ===
--- 
+++ 
@@ -5,17 +5,23 @@
 # make distclean: 	remove any superflous files (recursively)
 #----------------------------------------------------------------------
 
-OCAMLPATH=../../src
+.PHONY: all
+all: test_reader test_rewritten_reader
 
-test_reader: test_reader.ml
-	ocamllex minilex.mll
-	ocamlfind ocamlc -custom -o test_reader -package pxp,unix,threads \
+test_reader: test_reader.ml minilex.ml
+	ocamlfind ocamlc -o test_reader -package pxp,unix,threads \
 		-linkpkg -thread \
 		-g minilex.ml test_reader.ml
 
+test_rewritten_reader: test_rewritten_reader.ml minilex.ml
+	ocamlfind ocamlc -o test_rewritten_reader -package pxp,unix \
+		-linkpkg \
+		-g minilex.ml test_rewritten_reader.ml
+
+minilex.ml: minilex.mll
+	ocamllex minilex.mll
+
 #----------------------------------------------------------------------
-.PHONY: all
-all:
 
 .PHONY: clean
 clean:
@@ -27,5 +33,5 @@
 .PHONY: distclean
 distclean: clean
 	rm -f *~
-	rm -f test_reader
+	rm -f test_reader test_rewritten_reader

=== rtests/write/Makefile ===
# make validate:        make bytecode executable
# make validate.opt:    make native executable
# make clean: 		remove intermediate files (in this directory)
# make CLEAN:           remove intermediate files (recursively)
# make distclean: 	remove any superflous files (recursively)
#----------------------------------------------------------------------

.PHONY: all
all: test_write test_namespace

test_write: test_write.ml
	ocamlfind ocamlc -g -custom -o test_write -package pxp,str -linkpkg test_write.ml

test_namespace: test_namespace.ml
	ocamlfind ocamlc -g -custom -o test_namespace -package pxp,str -linkpkg test_namespace.ml -predicates pxp_without_utf8

#----------------------------------------------------------------------

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa out1 out2 out3

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~
	rm -f test_write test_namespace

=== src/pxp-engine/Makefile ===
TOP_DIR = ../..
include $(TOP_DIR)/Makefile.rules

all: 
	cp pxp_lib_ocamlc.ml pxp_lib.ml
	$(MAKE) generate
	$(MAKE) depend
	$(MAKE) -f Makefile.code all

opt: 
	cp pxp_lib_ocamlopt.ml pxp_lib.ml
	$(MAKE) generate
	$(MAKE) depend
	$(MAKE) -f Makefile.code opt

generate: pxp_core_parser.ml pxp_lexing.ml

.PHONY: depend
depend: 
	$(OCAMLDEP) *.ml *.mli >depend

clean:
	rm -f $(CLEAN_LIST) pxp_core_parser.ml pxp_lib.ml

CLEAN: clean

distclean: clean
	rm -f META depend

install:
	files=`$(COLLECT_FILES) *.mli *.cmi *.cma *.cmxa *.a pxp_top.cmo META` && \
	$(OCAMLFIND) install pxp-engine $$files

uninstall:
	$(OCAMLFIND) remove pxp-engine

pxp_lexing.ml: pxp_lexing.mlp
	$(IFDEF) $(LEXBUF_307) pxp_lexing.mlp

## pxp 1.1.95

=== Makefile ===
--- 
+++ 
@@ -12,6 +12,7 @@
 all:
 	$(MAKE) -C tools all
 	for pkg in $(PKGLIST); do $(MAKE) -C src/$$pkg all || exit; done
+	for pkg in $(GENPKGLIST); do $(MAKE) -C gensrc/$$pkg clean || exit; done
 	for pkg in $(GENPKGLIST); do $(MAKE) -C gensrc/$$pkg generate || exit; done
 	for pkg in $(GENPKGLIST); do $(MAKE) -C gensrc/$$pkg all || exit; done
 
@@ -19,6 +20,18 @@
 opt:
 	for pkg in $(PKGLIST); do $(MAKE) -C src/$$pkg opt || exit; done
 	for pkg in $(GENPKGLIST); do $(MAKE) -C gensrc/$$pkg opt || exit; done
+
+# The following are for development:
+.PHONY: lexers
+lexers:
+	for pkg in $(GENPKGLIST); do $(MAKE) -C gensrc/$$pkg generate || exit; done
+	for pkg in $(GENPKGLIST); do $(MAKE) -C gensrc/$$pkg all || exit; done
+
+.PHONY: lexers-again
+lexers-again:
+	for pkg in $(GENPKGLIST); do $(MAKE) -C gensrc/$$pkg clean || exit; done
+	$(MAKE) lexers
+
 
 # The following PHONY rule is important for Cygwin:
 .PHONY: install

=== tools/Makefile ===
TOP_DIR = ..
include $(TOP_DIR)/Makefile.rules

all:
	$(MAKE) -C src
	test -f m2parsergen$(EXEC_SUFFIX) || ln -s src/m2parsergen/m2parsergen$(EXEC_SUFFIX) .
	#test -f ucs2_to_utf8$(EXEC_SUFFIX) || ln -s src/ucs2_to_utf8/ucs2_to_utf8$(EXEC_SUFFIX) .
	test -f lexpp$(EXEC_SUFFIX) || ln -s src/lexpp/lexpp$(EXEC_SUFFIX)

clean:
	rm -f m2parsergen$(EXEC_SUFFIX) ucs2_to_utf8$(EXEC_SUFFIX) lexpp$(EXEC_SUFFIX)

CLEAN: clean
	$(MAKE) -C src CLEAN

distclean: clean
	$(MAKE) -C src distclean

=== src/pxp-pp/Makefile ===
TOP_DIR = ../..

include $(TOP_DIR)/Makefile.rules

PACKAGES = netstring,ulex,camlp4.quotations,camlp4.macro

OCAMLC_OPTIONS += -syntax camlp4o
OCAMLC_OPTIONS += $(CAMLP4_LOC)


all: pxp_pp.cma

opt:

pxp_pp.cma: pxp_pp.cmo
	$(OCAMLC) -a -o pxp_pp.cma pxp_pp.cmo

clean:
	rm -f $(CLEAN_LIST)

CLEAN: clean

distclean: clean
	rm -f META depend

install:
	$(OCAMLFIND) install pxp-pp pxp_pp.cma META

uninstall:
	$(OCAMLFIND) remove pxp-pp

## pxp 1.2.0~test1

=== examples/namespaces/Makefile ===
# make preprocess:	make bytecode executable
# make preprocess.opt: 	make native executable
# make clean: 		remove intermediate files
# make CLEAN:           remove intermediate files (recursively)
# make distclean: 	remove any superflous files
# make install
#----------------------------------------------------------------------

BIN = /usr/local/bin

preprocess: preprocess.ml
	ocamlfind ocamlc -g -o preprocess -package pxp,str -linkpkg preprocess.ml

preprocess.opt: preprocess.ml
	ocamlfind ocamlopt -o preprocess.opt -package pxp,str -linkpkg preprocess.ml


.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~ depend depend.pkg
	rm -f preprocess preprocess.opt

.PHONY: install
install:
	cp preprocess $(BIN)

=== examples/validate/Makefile ===
# make validate:        make bytecode executable
# make validate.opt:    make native executable
# make clean: 		remove intermediate files (in this directory)
# make CLEAN:           remove intermediate files (recursively)
# make distclean: 	remove any superflous files (recursively)
#----------------------------------------------------------------------

# REQ: This variable is set in Makefile.config

pxpvalidate: validate.ml
	ocamlfind ocamlc -g -o pxpvalidate -package "$(REQ)" -linkpkg validate.ml

pxpvalidate.opt: validate.ml
	ocamlfind ocamlopt -o pxpvalidate.opt -package "$(REQ)" -linkpkg validate.ml

# The following rules to create the bytecode executable assume O'Caml 3.03:

pxpvalidate.byte: validate.ml
	ocamlfind ocamlc -o pxpvalidate.byte -package "$(REQ)" -linkpkg validate.ml

pxpvalidate.1: pxpvalidate.pod
	pod2man --section=1 --center "www.ocaml-programming.de" --release 'PXP 1.1 tools' --lax pxpvalidate.pod >pxpvalidate.1

releasebyte:
	(cd ..; tar czf pxpvalidate-1.1.1.tar.gz pxpvalidate/{INSTALL,LICENSE,Makefile,pxpvalidate.1,pxpvalidate.byte,setup.sh,validate.ml})


Makefile.config:
	if ocamlfind query pxp-wlex-utf8 >/dev/null; then       \
	    lexer="pxp-lex-iso88591 pxp-wlex-utf8";             \
	else                                                    \
	    lexer="pxp-lex-iso88591 pxp-lex-utf8";              \
	fi;                                                     \
	echo "REQ = str pxp-engine $$lexer" >Makefile.config

#----------------------------------------------------------------------
.PHONY: all
all:

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~ Makefile.config
	rm -f pxpvalidate pxpvalidate.opt pxpvalidate.byte interpreter

include Makefile.config

=== rtests/write/Makefile ===
# make validate:        make bytecode executable
# make validate.opt:    make native executable
# make clean: 		remove intermediate files (in this directory)
# make CLEAN:           remove intermediate files (recursively)
# make distclean: 	remove any superflous files (recursively)
#----------------------------------------------------------------------

.PHONY: all
all: test_write test_namespace

test_write: test_write.cma
	../create-wrapper test_write

test_namespace: test_namespace.cma
	../create-wrapper test_namespace

test_write.cma: test_write.ml
	ocamlfind ocamlc -a -g -o test_write.cma -package pxp,str test_write.ml

test_namespace.cma: test_namespace.ml
	ocamlfind ocamlc -a -g -o test_namespace.cma -package pxp,str test_namespace.ml

#----------------------------------------------------------------------

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa out1 out2 out3
	rm -f test_write test_namespace

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~

=== src/pxp-engine/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 	$(OCAMLDEP) *.ml *.mli >depend
 
 clean:
-	rm -f $(CLEAN_LIST) pxp_core_parser.ml pxp_lib.ml
+	rm -f $(CLEAN_LIST) pxp_core_parser.ml pxp_lib.ml pxp_lexing.ml
 
 CLEAN: clean

=== src/pxp-pp/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 PACKAGES = netstring,ulex,camlp4.quotations,camlp4.macro
 
 OCAMLC_OPTIONS += -syntax camlp4o
-OCAMLC_OPTIONS += $(CAMLP4_LOC)
+OCAMLC_OPTIONS += $(CAMLP4_LOC) -ppopt -loc -ppopt loc
 
 
 all: pxp_pp.cma

=== tools/src/Makefile ===
all:
	$(MAKE) -C m2parsergen
#	$(MAKE) -C ucs2_to_utf8
	$(MAKE) -C lexpp

clean:

CLEAN: clean
	$(MAKE) -C m2parsergen CLEAN
#	$(MAKE) -C ucs2_to_utf8 CLEAN
	$(MAKE) -C lexpp CLEAN

distclean:
	$(MAKE) -C m2parsergen distclean
#	$(MAKE) -C ucs2_to_utf8 distclean
	$(MAKE) -C lexpp distclean

=== examples/xmlforms/styles/Makefile ===
.PHONY: all
all:

.PHONY: clean
clean:

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~

.PHONY: symlinks
symlinks:
	for x in *-style.xml; do ln -s ../xmlforms $${x%-style.xml} || true; done

=== tools/src/m2parsergen/Makefile ===
# make all: 		make bytecode executable
# make clean: 		remove intermediate files (in this directory)
# make CLEAN:           remove intermediate files (recursively)

#----------------------------------------------------------------------

TOP_DIR = ../../..
include $(TOP_DIR)/Makefile.rules

SRC = ast.ml lexer.ml parser.ml generator.ml
OBJ = $(SRC:.ml=.cmo)

#----------------------------------------------------------------------

.PHONY: all
all: m2parsergen$(EXEC_SUFFIX)

.PHONY: clean
clean:
	rm -f $(CLEAN_LIST) lexer.ml parser.ml parser.mli
	rm -f depend m2parsergen$(EXEC_SUFFIX) a.out x.ml

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean

depend: $(SRC) 
	$(OCAMLDEP) $(SRC) >depend

m2parsergen$(EXEC_SUFFIX): $(OBJ)
	$(OCAMLC) -o m2parsergen$(EXEC_SUFFIX) $(OBJ)

# Include dependencies:

include depend

## pxp 1.2.2

=== debian/changelog ===
pxp (1.2.2-1) unstable; urgency=low

  * Team upload
  * New upstream release
  * Remove Stefano from Uploaders
  * Bump Standards-Version to 3.9.2
  * Switch source package format to 3.0 (quilt)
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Sat, 23 Jul 2011 18:25:53 +0200

pxp (1.2.1-2) unstable; urgency=low

  [ Stefano Zacchiroli ]
  * debian/control
    - bump Standards-Version to 3.8.3 (no chances needed)
    - update Homepage field to a more specific location
    - add missing ${misc:Depends} on libpxp-ocaml-dev
  * debian/rules:
    - avoid using ocamldoc-apiref-config (which is now gone), instead ship
      a hand-written doc-base entry for upstream doc (Closes: #549750)
    - switch to dh_ocaml for dependency generation, bump deps on dh-ocaml
      accordingly. For the interim, keep old-style dependencies as well.
    - switch {debhelper,dpatch}.mk: fix debian/*.log cleanup

  [ Sylvain Le Gall ]
  * Clean examples/validate/Makefile.config

 -- Stefano Zacchiroli <zack@debian.org>  Tue, 06 Oct 2009 16:09:50 +0200

pxp (1.2.1-1) unstable; urgency=low

  [ Stefano Zacchiroli ]
  * New Upstream Version
  * Rebuild against OCaml 3.11, bump build-deps as needed
  * update watch file
  * debian/patches
    - remove patch build_w_camlp5 (no longer needed, pxp now builds fine
      with legacy camlp4 and ulex). As a consequence replace build-deps
      from camlp5/ulex08 to camlp4/ulex
    - add patch ocamldoc_missing_txt to avoid referencing an unavailable doc
  * debian/*.in use high level substvar instead of making assumptions on
    the stdlib dir location
  * bump debhelper compatibility to 7
  * debian/control
    - drop obsolete version specifications in build-deps
    - add build dep on dh-ocaml
    - bump Standards-Version to 3.8.1 (no changes)
    - move pxp to (new) archive section "ocaml"
  * debian/docs: avoid installing vanished documents
  * use upstream reference manual
  * debian/rules:
    - use ocaml.mk as a CDBS "rules" snippet
    - create destdir at the end of the build
    - generate doc-base entry for upstream ocamldoc API reference
  * debian/links: add link to preserve upstream manual dir structure

  [ Stephane Glondu ]
  * Switching packaging to git

 -- Stefano Zacchiroli <zack@debian.org>  Mon, 16 Mar 2009 16:57:08 +0100

pxp (1.2.0~test1-3) unstable; urgency=low

  * debian/control: fix typo in package short description (closes: #446909)
  * setting me as an uploader, d-o-m as the maintainer
  * update standards-versions, no changes needed
  * add Homepage field
  * move expansion of upstream comments to ocamldoc-like comments to a
    separate shell script, to avoid Makefile escaping issues
  * debian/rules: use ocamlfind to pass -I flags down to ocamldoc and add
    includes related to the netstring package

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 30 Dec 2007 09:33:33 +0100

pxp (1.2.0~test1-2) unstable; urgency=low

  * debian/rules
    - enable generation of ocamldoc API reference (via CDBS)

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 09 Sep 2007 12:18:47 +0200

pxp (1.2.0~test1-1) experimental; urgency=low

  * new upstream release
  * rebuild with OCaml 3.10 (whereas using camlp5 and ulex 0.8)
  * debian/watch
    - add watch file (for the development version)
  * bump debhelper deps and compatibility level to 5
  * debian/control
    - add build-dep on camlp5, ocaml-ulex08
  * debian/patches/
    - renamed patches to avoid numbers in their name, 00list is enough
    - add patch build_w_camlp5, ensure pxp is buildable against camlp5

 -- Stefano Zacchiroli <zack@debian.org>  Thu, 09 Aug 2007 16:49:18 -0400

pxp (1.1.96-8) unstable; urgency=low

  * debian/rules
    - use ocaml.mk
  * debian/control
    - bumped build dependency on ocaml-nox to >= 3.09.2-7, since we now use
      ocaml.mk

 -- Stefano Zacchiroli <zack@debian.org>  Sat,  4 Nov 2006 09:26:41 +0100

pxp (1.1.96-7) unstable; urgency=low

  * debian/control
    - bumped dependencies on ocamlnet

 -- Stefano Zacchiroli <zack@debian.org>  Wed, 13 Sep 2006 17:40:03 +0200

pxp (1.1.96-6) unstable; urgency=low

  * debian/rules
    - avoid to create debian/control from debian/control.in on ocamlinit
    - removed from the source package files which are generated at build time
      from the corresponding .in files
  * debian/control.in
    - file removed, no longer needed

 -- Stefano Zacchiroli <zack@debian.org>  Tue,  5 Sep 2006 22:36:25 +0200

pxp (1.1.96-5) unstable; urgency=low

  * Upload to unstable.

 -- Stefano Zacchiroli <zack@debian.org>  Wed, 17 May 2006 02:33:12 +0000

pxp (1.1.96-4) experimental; urgency=low

  * Rebuilt against OCaml 3.09.2, bumped deps accordingly.
  * Bumped Standards-Version to 3.7.2 (no changes needed).

 -- Stefano Zacchiroli <zack@debian.org>  Thu, 11 May 2006 23:38:22 +0000

pxp (1.1.96-3) unstable; urgency=low

  * Rebuilt against OCaml 3.09.1, bumped deps accordingly.

 -- Stefano Zacchiroli <zack@debian.org>  Sun,  8 Jan 2006 13:16:07 +0100

pxp (1.1.96-2) unstable; urgency=low

  * debian/control
    - tighter build-dep on ocamlnet, fixes FTBFS (closes: #340948)

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 27 Nov 2005 11:37:14 +0100

pxp (1.1.96-1) unstable; urgency=low

  * new upstream release
  * rebuilt with ocaml 3.09
  * debian/*
    - no more hardcoding of ocaml abi version anywhere
  * debian/rules
    - use cdbs

 -- Stefano Zacchiroli <zack@debian.org>  Sat, 26 Nov 2005 19:08:25 +0100

pxp (1.1.95-7) unstable; urgency=low

  * debian/control
    - rebuilt against latest netstring (bumped ocamlnet deps accordingly)
    - bumped ulex deps
    - bumped standards-version

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 31 Jul 2005 20:51:24 +0200

pxp (1.1.95-6) unstable; urgency=low

  * Rebuilt against ocaml 3.08.3
  * No longer built with wlex support (since wlex is no longer supported
    upstream and corresponding package has been removed from the debian
    archive)



=== debian/control ===
Source: pxp
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Build-Depends:
 debhelper (>= 7),
 ocaml-nox,
 dh-ocaml (>= 0.9),
 ocaml-findlib,
 libocamlnet-ocaml-dev (>= 2.2.9-6),
 ocaml-ulex,
 camlp4,
 cdbs
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/pxp.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/pxp.git
Homepage: http://projects.camlcity.org/projects/pxp.html

Package: libpxp-ocaml-dev
Architecture: any
Depends:
 ocaml-nox-${F:OCamlABI},
 libocamlnet-ocaml-dev,
 ocaml-findlib,
 ocaml-ulex,
 ${misc:Depends},
 ${ocaml:Depends}
Provides: ${ocaml:Provides}
Description: OCaml library that implements an XML-1.0 validating parser
 PXP is a validating parser for XML-1.0 which has been written entirely
 in Objective Caml.
 .
 PXP is the new name of the parser formerly known as "Markup". PXP means
 "Polymorphic XML parser" and emphasizes its most useful property: that
 the API is polymorphic and can be configured such that different objects
 are used to store different types of elements.

## pxp 1.2.4

=== Makefile ===
--- 
+++ 
@@ -72,18 +72,3 @@
 RELEASE:
 	./configure -version >RELEASE
 
-.PHONY: dist
-dist: RELEASE
-	./release
-
-.PHONY: tag-release
-tag-release: RELEASE
-	@echo Checking whether everything is checked in...
-	! cvs -n update 2>&1 | grep '^[MACPU] '
-	r=`head -1 RELEASE | sed -e s/\\\./-/g`; cd ..; cvs tag -F $(NAME)-$$r pxp
-
-.PHONY: release
-release: 
-	$(MAKE) tag-release
-	$(MAKE) dist
-

=== examples/Makefile ===
--- 
+++ 
@@ -11,6 +11,9 @@
 	$(MAKE) -C readme CLEAN
 	$(MAKE) -C simple_transformation CLEAN
 	$(MAKE) -C namespaces CLEAN
+	$(MAKE) -C eventparser CLEAN
+	$(MAKE) -C pullparser CLEAN
+	$(MAKE) -C xhtml2html CLEAN
 
 .PHONY: distclean
 distclean: clean
@@ -20,6 +23,8 @@
 	$(MAKE) -C readme distclean
 	$(MAKE) -C simple_transformation distclean
 	$(MAKE) -C namespaces distclean
+	$(MAKE) -C eventparser distclean
+	$(MAKE) -C pullparser distclean
+	$(MAKE) -C xhtml2html distclean
 
 
-

=== src/pxp-engine/Makefile ===
--- 
+++ 
@@ -19,6 +19,10 @@
 depend: 
 	$(OCAMLDEP) *.ml *.mli >depend
 
+.PHONY: doc
+doc:
+	$(MAKE) -f Makefile.code pxp_engine.dump
+
 clean:
 	rm -f $(CLEAN_LIST) pxp_core_parser.ml pxp_lib.ml pxp_lexing.ml

=== tools/src/lexpp/Makefile ===
TOP_DIR = ../../..
include $(TOP_DIR)/Makefile.rules

all: lexpp$(EXEC_SUFFIX)

DEPOBJS = lexpp_file.ml uni_lexer.ml uni_parser.ml uni_parser.mli \
	  uni_types.ml ucs2_to_utf8.ml main.ml mll_lexer.ml

OBJS = uni_types.cmo uni_lexer.cmo uni_parser.cmo lexpp_file.cmo \
	mll_lexer.cmo \
       ucs2_to_utf8.cmo main.cmo

PACKAGES=netstring

uni_lexer.ml: uni_lexer.mll
	$(OCAMLLEX) uni_lexer.mll

mll_lexer.ml: mll_lexer.mll
	$(OCAMLLEX) mll_lexer.mll

uni_parser.ml: uni_parser.mly
	$(OCAMLYACC) uni_parser.mly

uni_parser.mli: uni_parser.mly
	$(OCAMLYACC) uni_parser.mly

depend: $(DEPOBJS)
	$(OCAMLDEP) $(DEPOBJS) > depend

lexpp$(EXEC_SUFFIX): $(OBJS)
	$(OCAMLC) -o lexpp$(EXEC_SUFFIX) -linkpkg $(OBJS)

lexpp.cma: $(OBJS)
	$(OCAMLC) -o lexpp.cma -a $(OBJS)

clean:
	rm -f $(CLEAN_LIST) uni_lexer.ml uni_parser.ml uni_parser.mli \
	mll_lexer.ml \
	lexpp$(EXEC_SUFFIX) depend

CLEAN: clean

distclean: clean

include depend

=== tools/src/odoc/Makefile ===
TOP_DIR = ../../..
include $(TOP_DIR)/Makefile.rules

SRC = chtml.ml
OBJ = $(SRC:.ml=.cmo)
OCAMLC_OPTIONS += -I +ocamldoc
CLEAN_LIST += chtml.ml

.PHONY: all
all: chtml.cmo

chtml.ml:
	case `ocamlc -version` in \
	  3.*) cp chtml_ocaml3.ml chtml.ml ;; \
	  4.*) cp chtml_ocaml4.ml chtml.ml ;; \
	  *)   echo "Unknown Ocaml version"; exit 1 ;; \
	esac


.PHONY: clean
clean:
	rm -f $(CLEAN_LIST)

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean

=== debian/changelog ===
pxp (1.2.4-1build1) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 22:02:18 +0000

pxp (1.2.4-1) unstable; urgency=low

  * Team upload
  * New upstream release
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Thu, 11 Jul 2013 11:21:26 +0200

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,8 @@
  camlp4,
  cdbs
 Standards-Version: 3.9.2
-Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/pxp.git
-Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/pxp.git
+Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/pxp.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/pxp.git
 Homepage: http://projects.camlcity.org/projects/pxp.html
 
 Package: libpxp-ocaml-dev

## pxp 1.2.7

=== gensrc/pxp-lex-pattern/Makefile ===
clean:

CLEAN:

distclean:

=== rtests/dynamic/Makefile ===
# make validate:        make bytecode executable
# make validate.opt:    make native executable
# make clean: 		remove intermediate files (in this directory)
# make CLEAN:           remove intermediate files (recursively)
# make distclean: 	remove any superflous files (recursively)
#----------------------------------------------------------------------

all: create_element modify strip symmetry

create_element: create_element.ml
	ocamlfind ocamlc -labels -g -a -o create_element.cma -package pxp create_element.ml
	../create-wrapper create_element

modify: modify.ml
	ocamlfind ocamlc -g -a -o modify.cma -package pxp modify.ml
	../create-wrapper modify

strip: strip.ml
	ocamlfind ocamlc -g -a -o strip.cma -package pxp strip.ml
	../create-wrapper strip

symmetry: symmetry.ml
	ocamlfind ocamlc -g -a -o symmetry.cma -package pxp symmetry.ml
	../create-wrapper symmetry

#----------------------------------------------------------------------
.PHONY: all
all:

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa out.xml
	rm -f create_element modify strip

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~

=== rtests/reader/Makefile ===
--- 
+++ 
@@ -8,14 +8,19 @@
 .PHONY: all
 all: test_reader test_rewritten_reader
 
-test_reader: test_reader.ml minilex.ml
-	ocamlfind ocamlc -o test_reader -package pxp,unix,threads \
-		-linkpkg -thread \
+test_reader: test_reader.cma
+	../create-wrapper test_reader
+
+test_rewritten_reader: test_rewritten_reader.cma
+	../create-wrapper test_rewritten_reader
+
+test_reader.cma: test_reader.ml minilex.ml
+	ocamlfind ocamlc -a -o test_reader.cma -package pxp,unix,threads \
+		-thread \
 		-g minilex.ml test_reader.ml
 
-test_rewritten_reader: test_rewritten_reader.ml minilex.ml
-	ocamlfind ocamlc -o test_rewritten_reader -package pxp,unix \
-		-linkpkg \
+test_rewritten_reader.cma: test_rewritten_reader.ml minilex.ml
+	ocamlfind ocamlc -a -o test_rewritten_reader.cma -package pxp,unix \
 		-g minilex.ml test_rewritten_reader.ml
 
 minilex.ml: minilex.mll
@@ -26,6 +31,7 @@
 .PHONY: clean
 clean:
 	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa minilex.ml
+	rm -f test_reader test_rewritten_reader
 
 .PHONY: CLEAN
 CLEAN: clean
@@ -33,5 +39,5 @@
 .PHONY: distclean
 distclean: clean
 	rm -f *~
-	rm -f test_reader test_rewritten_reader
 
+

=== tools/src/lexpp/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	mll_lexer.cmo \
        ucs2_to_utf8.cmo main.cmo
 
-PACKAGES=netstring
+PACKAGES=netstring $(NETUNIDATA)
 
 uni_lexer.ml: uni_lexer.mll
 	$(OCAMLLEX) uni_lexer.mll

=== debian/changelog ===
pxp (1.2.7-1build2) xenial; urgency=medium

  * No-change rebuild against ocaml 4.02.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Wed, 04 Nov 2015 21:44:35 -0600

pxp (1.2.7-1build1) wily; urgency=medium

  * No-change ocaml rebuild.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 01 Sep 2015 13:58:48 +0200

pxp (1.2.7-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Switch debian/copyright to format 1.0
  * Bump Standards-Version to 3.9.6
  * Bump debhelper compat level to 9

 -- Stéphane Glondu <glondu@debian.org>  Mon, 04 May 2015 20:36:54 -0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Build-Depends:
- debhelper (>= 7),
+ debhelper (>= 9),
  ocaml-nox,
  dh-ocaml (>= 0.9),
  ocaml-findlib,
@@ -11,7 +11,7 @@
  ocaml-ulex,
  camlp4,
  cdbs
-Standards-Version: 3.9.2
+Standards-Version: 3.9.6
 Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/pxp.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/pxp.git
 Homepage: http://projects.camlcity.org/projects/pxp.html

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/ocaml.mk

PKGNAME = libpxp-ocaml-dev
DESTDIR=$(CURDIR)/debian/$(PKGNAME)$(OCAML_STDLIB_DIR)
DEB_MAKE_INSTALL_TARGET = install DESTDIR=$(DESTDIR)

configure/$(PKGNAME)::
	./configure -without-wlex -without-wlex-compat
	rm -f README	# it's a symlink, the real one is doc/README
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
build/$(PKGNAME)::
	$(MAKE) opt
endif
binary-post-install/$(PKGNAME)::
	-for f in debian/$(PKGNAME)/usr/share/doc/$(PKGNAME)/examples/xmlforms/styles/* ; do \
		test ! -r $$f && rm -f $$f ; \
	done

## pxp 1.2.8

=== debian/changelog ===
pxp (1.2.8-1build1) zesty; urgency=medium

  * Rebuild against new OCaml ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Dec 2016 20:34:39 +0100

pxp (1.2.8-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Update Vcs-*
  * Bump Standards-Version to 3.9.8

 -- Stéphane Glondu <glondu@debian.org>  Fri, 12 Aug 2016 14:19:11 +0200

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,13 @@
  ocaml-nox,
  dh-ocaml (>= 0.9),
  ocaml-findlib,
- libocamlnet-ocaml-dev (>= 2.2.9-6),
+ libocamlnet-ocaml-dev (>= 4.1),
  ocaml-ulex,
  camlp4,
  cdbs
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/pxp.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/pxp.git
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/pxp.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/pxp.git
 Homepage: http://projects.camlcity.org/projects/pxp.html
 
 Package: libpxp-ocaml-dev
